%% part a)

mu1 = [3; 6];
mu2 = [3;-2];

C1 = [0.5 0; 0 2];
C2 = [2 0; 0 2];

% calculate the eigenvectors and eigenvalues
[V1,D1] = eig(C1);
[V2,D2] = eig(C2);

%% part c)
x1 = linspace(-10,10,100);               % Let x1 go from -10 to 10
x2 = 3.5142-1.125.*x1 + 0.1875.*x1.^2;     % This is our decision boundary

figure(1)
plot(x1,x2)
axis([-10 10 -10 10])
title('The decision boudary');
xlabel('x1');
ylabel('x2');
drawnow();

%% part d)

feat1 = repmat([linspace(-10,10,20)]',1,20);
feat2 = repmat([linspace(-10,10,20)],20,1);
class = zeros(20,20);

figure(2)
subplot(211)
imshow(feat1,[])
title('Feature 1');
subplot(212)
imshow(feat2,[])
title('Feature 2');
drawnow();

figure(3)
scatter(feat1(:),feat2(:),'x')
xlabel('x1');
ylabel('x2');
title('Scatterplot of features');
drawnow();

%% part e)
for i = 1:length(feat1)
    for j = 1:length(feat2)
        if (feat2(i,j) > (3.5142-1.125*feat1(i,j) + 0.1875*feat1(i,j)^2))
            class(i,j) = 1;
        else
            class(i,j) = 2;
        end
    end
end

% Lets plot the feature space with the classes indicated by color
figure(4)
scatter(feat1(:),feat2(:),[],class(:),'fill')
colorbar
colormap winter
title('Classified feature space');
xlabel('x1');
ylabel('x2');
drawnow();