% Load the file tm.mat
rawdata = load('tm.mat');
num_bands = 6;

% Put all the image data into a long pattern vector
data = zeros(260*333, num_bands);
fields = fieldnames(rawdata);
for ii = 1:num_bands
    tmp = rawdata.(fields{ii});
    data(:, ii) = double(tmp(:));
end

% Compute the covariance matrix of the data vector
cov_mat = cov(x);

% Use eig() to find the eigenvectors and eigenvalues of the covariance
% matrix and form the A matrix
[A,d] = eig(cov_mat);
eigvals = diag(d);

% Form the 6 principal components
pcas=x*A;

% Convert the 6 principal component nx6 vectors back to the 2D image
% geometry
pca_imgs = reshape(pcas, [260, 333, num_bands]);

% Display the principal component images.
figure()
for ii = 1:num_bands
    subplot(2,3,ii)
    imagesc(squeeze(pca_imgs(:,:,ii)))
    title(sprintf('PCA image %d',ii))
end

% Plot the eigenvalues scaled by the sum of all eigenvalues
figure()
plot(1:num_bands, eigvals./sum(eigvals),'bo--')
title('eigenvalues scaled')